Citizen.CreateThread(function()
    while true do
        Citizen.Wait(500)
        local playerPed = PlayerPedId()
        local playerCoords = GetEntityCoords(playerPed)

        local success, groundZ = GetGroundZFor_3dCoord(playerCoords.x, playerCoords.y, playerCoords.z, 0)

        if success then
            local offsetZ = playerCoords.z - groundZ

            if offsetZ < -2.0 then

                local safeCoords = vector3(playerCoords.x, playerCoords.y, groundZ + 1.0)

                SetEntityCoordsNoOffset(playerPed, safeCoords.x, safeCoords.y, safeCoords.z, true, true, true)
                TriggerEvent('chat:addMessage', { args = { 'System', 'You were stuck and moved to a safe position.' } })
            end
        end
    end
end)

RegisterCommand("stuck", function()
    local playerPed = PlayerPedId()
    local playerCoords = GetEntityCoords(playerPed)

    local success, groundZ = GetGroundZFor_3dCoord(playerCoords.x, playerCoords.y, playerCoords.z, 0)

    if success then
        local offsetZ = playerCoords.z - groundZ

        if offsetZ < -2.0 then
            local safeCoords = vector3(playerCoords.x, playerCoords.y, groundZ + 1.0)
            SetEntityCoordsNoOffset(playerPed, safeCoords.x, safeCoords.y, safeCoords.z, true, true, true)
            TriggerEvent('chat:addMessage', { args = { 'System', 'You have been manually unstuck and moved to a safe position.' } })
        else
            TriggerEvent('chat:addMessage', { args = { 'System', 'You are not stuck, no need to use /stuck.' } })
        end
    else
        TriggerEvent('chat:addMessage', { args = { 'System', 'Unable to find a safe position.' } })
    end
end, false)
TriggerEvent('chat:addSuggestion', '/stuck', 'Move to a safe position if you are stuck.')
