local maxConnectionsPerIp = 5
local connectionAttempts = {}
AddEventHandler('playerConnecting', function(playerName, setKickReason, deferrals)
    local ip = GetPlayerEndpoint(source)
    if not connectionAttempts[ip] then
        connectionAttempts[ip] = { count = 1, lastAttempt = os.time() }
    else
        if os.time() - connectionAttempts[ip].lastAttempt < 60 then
            connectionAttempts[ip].count = connectionAttempts[ip].count + 1
        else
            connectionAttempts[ip].count = 1
        end
        connectionAttempts[ip].lastAttempt = os.time()
    end
    if connectionAttempts[ip].count > maxConnectionsPerIp then
        setKickReason("Too many connection attempts. Please try again later.")
        deferrals.done()
    else
        deferrals.done()
    end
end)
